//+------------------------------------------------------------------+
//|                                                          RAD.mq4 |
//|                                              Daniel Vieira Costa |
//|                              Paypal donations danielvc@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Daniel Vieira Costa"
#property link      "Paypal donations danielvc@gmail.com"
extern int MagicNumber = 1;
extern bool OneTradePerBar = true;
extern double TargetProfit = 10;
extern bool UseATRStopLoss = false;
extern int ATRPeriod = 24;
extern double StopLoss = 30;
extern double Slippage = 10;
extern bool CloseBuyOrders = true;
extern bool CloseSellOrders = true;
extern double Lot  = 0.01;
extern double DecreaseFactor     = 3;
extern int LotDecimal = 2; // 1 = 0.10; 2 = 0.01
extern double MaxSpread = 2.00;
extern bool UseRecover = false;
extern double RiskPercent = 1;
extern double Multiplier = 4;
extern string _indicators = "-- Some parameters of indicators --";
extern int EnvelopePeriod = 8;
extern double EnvelopeDeviation = 0.10;
extern int EnvelopeMAMethod = 0;
extern string _indicatorsOptions = "-- Options --";
extern bool GeneratesEquityChart = false;
extern bool UseVirtualTargetProfit = true;
extern bool AllowHedge = false;
extern int PipStep = 30;
extern double PipStepExponent = 1.3;
extern double LotExponent = 1.59;   //  0.1, : 0.16, 0.26, 0.43 ...
extern double LotDigits=2; // lot digits, 1 for mini, 2 for micro 
extern string Comentario = "Stoch";
int _tick = 0;
int _lastTradedBar = 0;
int _lastBarPloted = 0;
int _tickByTick = 0;
double _point = 0;
double _pipStep = 0;
int _pointDiv = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if (Digits==3 || Digits==5)
   {
      TargetProfit = TargetProfit * 10;
      StopLoss = StopLoss * 10;
      Slippage = Slippage * 10;
      _point = Point * 10;
      _pointDiv = 10;
   }
   else
   {
      _point = Point;
      _pointDiv = 1;
   }     
//----
   
//----
   return(0);
  }


string ErrorDescription(int error_code)
  {
   string error_string;
//----
   switch(error_code)
     {
      //---- codes returned from trade server
      case 0:
      case 1:   error_string="no error";                                                  break;
      case 2:   error_string="common error";                                              break;
      case 3:   error_string="invalid trade parameters";                                  break;
      case 4:   error_string="trade server is busy";                                      break;
      case 5:   error_string="old version of the client terminal";                        break;
      case 6:   error_string="no connection with trade server";                           break;
      case 7:   error_string="not enough rights";                                         break;
      case 8:   error_string="too frequent requests";                                     break;
      case 9:   error_string="malfunctional trade operation (never returned error)";      break;
      case 64:  error_string="account disabled";                                          break;
      case 65:  error_string="invalid account";                                           break;
      case 128: error_string="trade timeout";                                             break;
      case 129: error_string="invalid price";                                             break;
      case 130: error_string="invalid stops";                                             break;
      case 131: error_string="invalid trade volume";                                      break;
      case 132: error_string="market is closed";                                          break;
      case 133: error_string="trade is disabled";                                         break;
      case 134: error_string="not enough money";                                          break;
      case 135: error_string="price changed";                                             break;
      case 136: error_string="off quotes";                                                break;
      case 137: error_string="broker is busy (never returned error)";                     break;
      case 138: error_string="requote";                                                   break;
      case 139: error_string="order is locked";                                           break;
      case 140: error_string="long positions only allowed";                               break;
      case 141: error_string="too many requests";                                         break;
      case 145: error_string="modification denied because order too close to market";     break;
      case 146: error_string="trade context is busy";                                     break;
      case 147: error_string="expirations are denied by broker";                          break;
      case 148: error_string="amount of open and pending orders has reached the limit";   break;
      case 149: error_string="hedging is prohibited";                                     break;
      case 150: error_string="prohibited by FIFO rules";                                  break;
      //---- mql4 errors
      case 4000: error_string="no error (never generated code)";                          break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed in the expert properties";            break;
      case 4110: error_string="longs are not allowed in the expert properties";           break;
      case 4111: error_string="shorts are not allowed in the expert properties";          break;
      case 4200: error_string="object is already exist";                                  break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object is not exist";                                      break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      default:   error_string="unknown error";
     }
//----
   return(error_string);
  } 

bool isThereMoreThanDefaulLot()
{
   bool have = false;
   for(int i=OrdersTotal()-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS)==true) 
         if(OrderLots() > Lot)
         {
            have = true;
            return (have);
         }       

   } 
   return (have);
}

double LotsOptimized()
  {
   double _lot;
   
   if (RiskPercent == 0)
      _lot = Lot;
   else   
      _lot = NormalizeDouble(AccountFreeMargin()*(RiskPercent/1000)/100.0,2);



   if(isThereMoreThanDefaulLot())
      return (Lot);
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   double biggerLotTraded = 0.01;
   

   for(int i=orders-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) 
      { 
         Print("Error in history!"); 
         break; 
      }

      if(OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber || OrderType()>OP_SELL) 
         continue;
      //----
      if(OrderProfit()>0) break;
      if(OrderProfit()<0) 
      {
         losses++;
         if (OrderLots() > biggerLotTraded)
            biggerLotTraded = OrderLots();
      }   
   } 
   if(losses>=1 && UseRecover) 
      _lot=(biggerLotTraded * Multiplier);

   if (_lot > MarketInfo(Symbol(), MODE_MAXLOT))
      return (MarketInfo(Symbol(), MODE_MAXLOT));
   if(_lot<MarketInfo(Symbol(), MODE_MINLOT)) _lot=MarketInfo(Symbol(), MODE_MINLOT);
   
   return(_lot);
  }

void fechaPosicoes(int tipo)
{
   if (tipo==OP_BUY)
   while (getTotalOrdemByType(OP_BUY) > 0)
   {
      for (int i = 0; i<OrdersTotal(); i++)
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
               if (OrderType()== tipo)
                  if (OrderClose(OrderTicket(),OrderLots(), NormalizeDouble(Bid, Digits),0,Blue) == false)
                  {
                     Print("Error to close a buy order. Reason: " + ErrorDescription(GetLastError()));
                     Print("Waiting to try again...");
                     Sleep(100);
                     RefreshRates();
                  }   
   }            

   if (tipo==OP_SELL)
   while (getTotalOrdemByType(OP_SELL) > 0)
   {
      for (int a = 0; a<OrdersTotal(); a++)
         if (OrderSelect(a, SELECT_BY_POS, MODE_TRADES))
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
               if (OrderType()== tipo)
                  if (OrderClose(OrderTicket(),OrderLots(), NormalizeDouble(Ask, Digits),0,Red) == false)
                  {
                     Print("Error to close a sell order. Reason: " + ErrorDescription(GetLastError()));
                     Print("Waiting to try again...");
                     Sleep(100);
                     RefreshRates();
                  }   

   }            
   
   return ;      
}
  
int getTotalOrdemByType (int type)
{
   // retorna o total de ordens por tipo BUY/SELL
   int cont = 0;
   for (int i = 0; i<OrdersTotal(); i++)
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
            if (OrderType()== type)
               cont++;
   return (cont);         
}




//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
  
bool lastTradeWasBad()
{
   bool bad = false;
   // it is look for all orders of all pairs traded
   if(OrderSelect(OrdersHistoryTotal()-1, SELECT_BY_POS, MODE_HISTORY))
      if(OrderProfit()<=0)
      {
         bad = true;
      }   
   return (bad);
}

void virtualTP()
{
   for (int i = 0; i<OrdersTotal(); i++)
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
            if (OrderType()== OP_BUY || OrderType()== OP_BUYLIMIT)
            {
               if (NormalizeDouble(Bid-OrderOpenPrice(), Digits) >= (TargetProfit * Point))
                  if (OrderClose(OrderTicket(),OrderLots(), Ask,0,Blue) == false)
                  {
                     Print("Error to close a buy order. Reason: " + ErrorDescription(GetLastError()));
                     Print("Waiting to try again...");
                     Sleep(100);
                     RefreshRates();
                  }  
            }
            else
            if (OrderType()== OP_SELL || OrderType()== OP_SELLLIMIT)
            {
               if (NormalizeDouble(OrderOpenPrice()-Ask, Digits) >= (TargetProfit * Point))
                  if (OrderClose(OrderTicket(),OrderLots(), Bid,0, Red) == false)
                  {
                     Print("Error to close a buy order. Reason: " + ErrorDescription(GetLastError()));
                     Print("Waiting to try again...");
                     Sleep(100);
                     RefreshRates();
                  }   
            }   
   return ;      
   
}  

void enviaOrdem(int tipo, string comentario, double lote, int mn)
{
   double _stopLoss = 0;
   int ticket = -1;         


   if (tipo == OP_BUY)
   {
      // only fill the SL when filled
      if (StopLoss > 0)
      {
         if (UseATRStopLoss)
            _stopLoss = Ask-(iATR(Symbol(), 0, ATRPeriod, 0));
         else
            _stopLoss = Ask-(StopLoss*Point);
      }
      if(ticket==-1)
      {
         ticket = OrderSend(Symbol(), tipo, lote, Ask, Slippage, 0, Ask + (TargetProfit * Point), comentario, mn, 0, Blue);
         
         Print("Lote invlido = " + lote);
         if (GetLastError() == 134)
            lote = lote - (lote / Multiplier);  
         if (lote < Lot)
            lote = Lot;
         RefreshRates();
         Sleep(100);
      }
      if (ticket > 0)
         if (OrderSelect(ticket, SELECT_BY_TICKET)== true)
            if (_stopLoss > 0)
               if(OrderModify(ticket, OrderOpenPrice(), _stopLoss, OrderTakeProfit(), 0, Blue ) == false)
               {
                  RefreshRates();
                  Sleep(100);
               }
   
   }
   else
   if (tipo == OP_SELL)
   {
      if (StopLoss > 0)
      {
         if(UseATRStopLoss)
            _stopLoss = Bid+(iATR(Symbol(), 0, ATRPeriod, 0));
         else
            _stopLoss = Bid+(StopLoss*Point);
      }
      if(ticket==-1)
      {
         ticket = OrderSend(Symbol(), OP_SELL, lote, Bid, Slippage, 0, Bid-(TargetProfit * Point), NULL, mn, 0, Red);
         Print("Lote invlido = " + lote);
         if (GetLastError() == 134)
            lote = lote - (lote / 4);  
            
         RefreshRates();
         Sleep(100);
      }
      if (ticket > 0)
         if (OrderSelect(ticket, SELECT_BY_TICKET)== true)
            if (_stopLoss > 0)
               if(OrderModify(ticket, OrderOpenPrice(), _stopLoss, OrderTakeProfit(), 0, Blue ) == false)
               {
                  RefreshRates();
                  Sleep(100);
               }
   
   }    
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   
   _tickByTick = _tickByTick + 1; 
   if (_tickByTick == 100)
   {
      if (GeneratesEquityChart)
         recordEquity("Stochastic", 1);
      _tickByTick = 0;            
   }
   
   // reached max spread
   if (MathAbs(Ask-Bid) > (MaxSpread * _point))
   {
      Print("Spread too wide: " + MathAbs(Ask-Bid));
      return(0);
   }
   
   if(UseVirtualTargetProfit)
      virtualTP();
   
//----
   if (_tick == 0)
      _tick = Bars;
   
   if (_tick == Bars)
   {
      Print("First bar never will be traded");
      //return;  
   }
   else
   {
      
      double LastBuyPrice, LastSellPrice;

//      if (_lastTradedBar != Bars)
      
      // buy
      if (iStochastic(Symbol(), 0, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, 0) > 0.00 && iStochastic(Symbol(), 0, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, 1) <= 0.00)
      {
      
         if (CloseSellOrders)
            fechaPosicoes(OP_SELL);
         
         // se o total de ordem for = 0
         if (getTotalOrdemByType(OP_BUY) == 0)
//         if (OrdersTotal() == 0)
         {
         
            if (_lastTradedBar != Bars && OneTradePerBar)
            {

               //if ((Close[1] > iEnvelopes(Symbol(), 0, EnvelopePeriod, EnvelopeMAMethod, 0, PRICE_MEDIAN, EnvelopeDeviation, MODE_UPPER, 0))   )
               {
                  //if (iCustom(Symbol(), 0, "wmmm", 15, 0, 1, 1) != EMPTY_VALUE && iCustom(Symbol(), 0, "wmmm", 15, 0, 2, 1) == EMPTY_VALUE)
                     //if (iCustom(Symbol(), 0, "FDI", 11, 0, 1.5, 1, 0) != EMPTY_VALUE && iCustom(Symbol(), 0, "FDI", 11, 0, 1.5, 1, 0) <= 1.50)
                     enviaOrdem(OP_BUY,Comentario, LotsOptimized(), MagicNumber);
               }
               _lastTradedBar = Bars  ;
            }
            else
            {
               enviaOrdem(OP_BUY,Comentario, LotsOptimized(), MagicNumber);
            }
         }
      }
      else
      // sell
      if (NormalizeDouble(iStochastic(Symbol(), 0, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, 0), 2) < 100.00 && NormalizeDouble(iStochastic(Symbol(), 0, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, 1), 2) >= 100.00)
      {
         if (CloseBuyOrders)
            fechaPosicoes(OP_BUY);

         // se o total de ordem for = 0
         if (getTotalOrdemByType(OP_SELL) == 0)
//         if (OrdersTotal() == 0)
         {
            if (_lastTradedBar != Bars && OneTradePerBar)
            {
            
               // only fill the SL when filled
               //if ((Close[1] < iEnvelopes(Symbol(), 0, EnvelopePeriod, EnvelopeMAMethod, 0, PRICE_MEDIAN, EnvelopeDeviation, MODE_LOWER, 0))   )
               {
                  //if (iCustom(Symbol(), 0, "wmmm", 15, 0, 2, 1) != EMPTY_VALUE && iCustom(Symbol(), 0, "wmmm", 15, 0, 1, 1) == EMPTY_VALUE)
                     //if (iCustom(Symbol(), 0, "FDI", 11, 0, 1.5, 1, 0) != EMPTY_VALUE && iCustom(Symbol(), 0, "FDI", 11, 0, 1.5, 1, 0) <= 1.50)
                     enviaOrdem(OP_SELL, Comentario, LotsOptimized(), MagicNumber);
                     
               }        
               _lastTradedBar = Bars  ;
            }
            else
            {
               enviaOrdem(OP_SELL, Comentario, LotsOptimized(), MagicNumber);
            }
         }
         
      } 
   }

   // TRADE MANAGEMENT
   if (AllowHedge)
   {
      // if there are opened buy orders...
      if (getTotalOrdemByType(OP_BUY) >= 1)
      {
         // calcula o espao entre os trades na mesma direo
         //                          30                1.3             , 1
         _pipStep = NormalizeDouble(PipStep * MathPow(PipStepExponent, getTotalOrdemByType(OP_BUY)), 0);
         // if the last buy price reached the average price...
         if (FindLastBuyPrice(MagicNumber) - Ask >= _pipStep * _point)
         {
            //we start buying based on price average
            double ibuyLot = NormalizeDouble(Lot * MathPow(LotExponent, getTotalOrdemByType(OP_BUY)), LotDecimal);   
            enviaOrdem(OP_BUY, Comentario, ibuyLot, MagicNumber);      
         }
      }   
      if (getTotalOrdemByType(OP_SELL) >= 1)
      {
         // calcula o espao entre os trades na mesma direo
         //                          30                1.3             , 1
         _pipStep = NormalizeDouble(PipStep * MathPow(PipStepExponent, getTotalOrdemByType(OP_SELL)), 0);
         // if the last buy price reached the average price...
         if (Bid - FindLastSellPrice(MagicNumber) >= _pipStep * _point)
         {
            //we start buying based on price average
            double isellLot = NormalizeDouble(Lot * MathPow(LotExponent, getTotalOrdemByType(OP_SELL)), LotDecimal);   
            enviaOrdem(OP_SELL,Comentario, isellLot, MagicNumber);      
         }
   
      }
   }   
//----
   return(0);
  }
  
double FindLastBuyPrice(int mn) {
   double oldorderopenprice;
   int oldticketnumber;
   double unused = 0;
   int ticketnumber = 0;
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != mn) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == mn && OrderType() == OP_BUY) {
         oldticketnumber = OrderTicket();
         if (oldticketnumber > ticketnumber) {
            oldorderopenprice = OrderOpenPrice();
            unused = oldorderopenprice;
            ticketnumber = oldticketnumber;
         }
      }
   }
   return (oldorderopenprice);
}

double FindLastSellPrice(int mn) {
   double oldorderopenprice;
   int oldticketnumber;
   double unused = 0;
   int ticketnumber = 0;
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != mn) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == mn && OrderType() == OP_SELL) {
         oldticketnumber = OrderTicket();
         if (oldticketnumber > ticketnumber) {
            oldorderopenprice = OrderOpenPrice();
            unused = oldorderopenprice;
            ticketnumber = oldticketnumber;
         }
      }
   }
   return (oldorderopenprice);
}
  
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                               offline_charts.mq4 |
//|                                                     Bernd Kreuss |
//|                                              Version 2010.9.12.1 |
//|                 paypal-donations go here -> mailto:7ibt@arcor.de |
//+------------------------------------------------------------------+

/** @file
* This file contains functions, needed to handle offline charts,
* the latest version of this file is available at 
* http://sites.google.com/site/prof7bit/
*
* You can create or update offline charts in real time and also refresh
* the chart window associated with such an offline chart automatically, 
*
* The main purpose of this library is to be able to produce
* equity curves resulting from traded strategies in real time, 
* equity curves that would contain every drawdown that occured
* during the trades, not only closed profits. This is especially
* useful when used while backtesting an EA, unlike the built-in
* backtester equity plotter this one will record everything that
* happens while the positions are open and draw a much more 
* realistic picture.
*
* To use the equity plotter feature simply include the .mqh file in 
* your expert and then on every tick call the function recordEquity()
* For example if you have an EA with the name "foobazer" and want to
* record it's performance in an M15 chart you would issue the following
* call on every tick: 
* 
*   recordEquity("foobazer", PERIOD_M15, magic_number)
*
* 
* !!! Use a different name for every chart the EA runs on !!!
* The period has nothing to do with the period the EA runs on, it is
* just meant to tell the function which timeframe the equity chart should have
* and can be every period you want. In the above example It will create and 
* continually update an offline M15 chart with the name "foobazer" containing 
* the performance of your EA in real time from this moment on. If you run your 
* EA on backtester then an underscore will be prepended to the name of the chart,
* so it won't overwrite your live chart.
* 
* Names can only contain up to 12 characters. Make sure every EA on every 
* chart will use a DIFFERENT NAME when calling this function or they will 
* all write to the same chart and produce a complete mess.
*/

#include <WinUser32.mqh>

#define OFFLINE_HEADER_SIZE 148 ///< LONG_SIZE + 64 + 12 + 4 * LONG_SIZE + 13 * LONG_SIZE 
#define OFFLINE_RECORD_SIZE 44  ///< 5 * DOUBLE_SIZE + LONG_SIZE 

int __chart_file = 0; ///< the cache for the file handle (only used in backtesting mode) 

/**
* Record the equity curve for the specified filter critera into an offline chart.
* Call this function on every tick. It will produce a chart that will 
* include every high and low of the total floating and realized profits.
* 
* You can filter by magic number and/or by the comment field.
* If magic is -1 then all magic numbers are allowed, if it is 0 then 
* only manually opened trades are counted, if it is any other
* value then only trades with this particular number are counted. 
* The second filter is comment, if it is "" then it is not filtered
* by comment, else only trades with this exact comment string are
* counted.
* 
* Offset is used to make sure the chart always is in positive terrotory.
* Since metatrader won't display charts with negative values and we are
* only summing up an individual strategie's profit (or loss!), not total 
* equity, we need some imaginary positive starting capital for each chart.
*/
void recordEquity(string name, int period, int magic=-1, string comment="", double offset=5000){
   double equity;
   
   // don't do anything during optimization runs
   if (IsOptimization()){
      return(0);
   }
   
   // This can happen shortly after a restart of metatrader. The order history
   // is still empty. We do nothing in this case and wait for the next tick.
   if (OrdersHistoryTotal() == 0){
      return(0);
   }

   if (magic == -1 && comment == ""){
      // If there is no filter we can simply use AccountEquity(), also we
      // don't need a virtual starting balance in this case. 
      equity = AccountEquity();
   }else{
      // Otherwise calculate the partial profits and add 'offset' 
      // as virtual starting balance.
      equity = getAllProfitFiltered(magic, comment) + offset;
   }
      
   // when run in the strategy tester we add a _ to the chart name
   // so it wont interfere with the same chart in live trading
   if (IsTesting()){
      name = "_" + name;
   }
   
   // write it into the chart.
   updateOfflineChart(name, period, 2, equity, 0); 
}

/**
* Update the offline chart with a new price. 
* This function will find the last bar in the offline chart file 
* (create the chart if necessary) update the last bar (adjust the close, 
* add to the volume and extend high or low if necessary) or start a new bar 
* if current time is beyond the lifetime of the last bar in the chart.
* Note: if you want to make Renko or other range based charts you will need to
* write your own function similar to this but with a different algorithm to
* detect when a new bar must be started. This one is strictly time based.
*/ 
void updateOfflineChart(string symbol, int period, int digits, double price, double volume){
   double o,h,l,c,v;
   int t;
   int time_current = iTime(NULL, period, 0); // FIXME! the starting time for the period's current bar
   
   // create the chart if it doesn't already exist
   // or just update the header
   writeOfflineHeader(symbol, period, digits);
   
   // read the last bar in the chart (if any)
   if (!readOfflineBar(symbol, period, 1, t, o, h, l, c, v)){
      // no bars in chart yet, so just make one
      writeOfflineBar(symbol, period, 0, time_current, price, price, price, price, volume);
      return(0);
   }
   
   if (t > time_current){
      // this is a very special case: the last bar in the chart is
      // NEWER that the bar we just want to record. This can only
      // happen if we backtest and there is already a chart left
      // from a previous backtest. In this case the only reasonable
      // thing we would want to do is completely empty the chart and
      // start again.
      if (IsTesting()){
         // ONLY empty the chart if we REALLY are in the baktester, 
         // else we simply IGNORE it completely instead of accidently 
         // destroying a whole and possibly months old chart just 
         // because of one bad timestamp.
         emptyOfflineChart(symbol, period, digits);   
         writeOfflineBar(symbol, period, 0, time_current, price, price, price, price, volume);
      }
      return(0);
   }
   
   if (t == time_current){
      // the bar has the current time, so update it
      if (price > h){
         h = price;
      }
      if (price < l){
         l = price;
      }
      c = price;
      v += volume;
      writeOfflineBar(symbol, period, 1, t, o, h, l, c, v);
   }else{
      // last bar is old, start a new one
      writeOfflineBar(symbol, period, 0, time_current, price, price, price, price, volume);
   }  
}

/**
* empty the chart, write a fresh header
*/
void emptyOfflineChart(string symbol, int period, int digits){
   // close it first (if we are in the backtester and the file is kept open)
   forceFileClose();
      
   // open (and immediately close) the file in write only mode, 
   // this will truncate it to zero length, after that we write a fresh header
   FileClose(FileOpenHistory(offlineFileName(symbol, period), FILE_WRITE | FILE_BIN));
   writeOfflineHeader(symbol, period, digits);
}

/**
* write or update the header of an offline chart file,
* if the file does not yet exist create the file.
*/
void writeOfflineHeader(string symbol, int period, int digits){
   int    version = 400;
   string c_copyright = "(C)opyright 2009-2010, Bernd Kreuss";
   int    i_unused[13];
   
   int F = fileOpenEx(offlineFileName(symbol, period), FILE_BIN | FILE_READ | FILE_WRITE);
   FileSeek(F, 0, SEEK_SET);
   FileWriteInteger(F, version, LONG_VALUE);
   FileWriteString(F, c_copyright, 64);
   FileWriteString(F, symbol, 12);
   FileWriteInteger(F, period, LONG_VALUE);
   FileWriteInteger(F, digits, LONG_VALUE);
   FileWriteInteger(F, 0, LONG_VALUE);       //timesign
   FileWriteInteger(F, 0, LONG_VALUE);       //last_sync
   FileWriteArray(F, i_unused, 0, 13);

   fileCloseEx(F);
}

/**
* Write (or update) one bar in the offline chart file
* and refresh the chart window if it is currently open.
* The parameter bars_back is the offset counted from the end of
* the file: 0 means append a new bar, 1 means update the last bar
* 2 would be the second last bar and so on.
* The parameter time is the POSIX-Timestamp representing the 
* beginning of that bar. It is the same value that would be 
* returned from iTime() or Time[], namely the seconds that
* have passed since the UNIX-Epoch (00:00 a.m. of 1 January, 1970)
*/
void writeOfflineBar(string symbol, int period, int bars_back, int time, double open, double high, double low, double close, double volume){
   int F = fileOpenEx(offlineFileName(symbol, period), FILE_BIN | FILE_READ | FILE_WRITE);
   
   int position = bars_back * OFFLINE_RECORD_SIZE;   
   FileSeek(F, -position, SEEK_END);

   if (FileTell(F) >= OFFLINE_HEADER_SIZE){
      FileWriteInteger(F, time, LONG_VALUE); 
      FileWriteDouble(F, open, DOUBLE_VALUE);
      FileWriteDouble(F, low, DOUBLE_VALUE);
      FileWriteDouble(F, high, DOUBLE_VALUE);
      FileWriteDouble(F, close, DOUBLE_VALUE);
      FileWriteDouble(F, volume, DOUBLE_VALUE);
   
      // refresh the chart window
      // this won't work in backtesting mode
      // and also don't do it while deinitializing or the
      // WindowHandle() function will run into a deadlock
      // for unknown reasons. (this took me a while to debug)
      if (!IsStopped() && !IsTesting()){
         int hwnd=WindowHandle(symbol, period);
         if (hwnd != 0){
            PostMessageA(hwnd, WM_COMMAND, 33324, 0);
         }
      }
   }
   fileCloseEx(F);
}

/**
* Read one bar out of the offline chart file and fill the
* "by reference"-parameters that were passed to the function.
* The function returns True if successful or False otherwise.
* The parameter bars_back is the offset counting from the end
* of the file: 0 makes no sense since it would be past the end,
* 1 means read the last bar in the file, 2 the second last, etc.
* If bars_back would point outside the file (beginning or end)
* the function will return False and do nothing, otherwise
* the read values will be filled into the supplied parameters
* and the function will return True
*/ 
bool readOfflineBar(string symbol, int period, int bars_back, int& time, double& open, double& high, double& low, double& close, double& volume){
   int F = fileOpenEx(offlineFileName(symbol, period), FILE_BIN | FILE_READ | FILE_WRITE);
   
   int position = bars_back * OFFLINE_RECORD_SIZE;
   FileSeek(F, -position, SEEK_END);
   
   if (FileSize(F) - FileTell(F) >= OFFLINE_RECORD_SIZE && FileTell(F) >= OFFLINE_HEADER_SIZE){
      time = FileReadInteger(F, LONG_VALUE); 
      open = FileReadDouble(F, DOUBLE_VALUE);
      low = FileReadDouble(F, DOUBLE_VALUE);
      high = FileReadDouble(F, DOUBLE_VALUE);
      close = FileReadDouble(F, DOUBLE_VALUE);
      volume = FileReadDouble(F, DOUBLE_VALUE);
      fileCloseEx(F);
      return(True);
   }else{
      fileCloseEx(F);
      return(False);
   }
}

/**
* construct the file name for the chart file, truncate the 
* symbol name to the maximum of 12 allowed characters.
*/
string offlineFileName(string symbol, int period){
   return(StringSubstr(symbol, 0, 12) + period + ".hst");
}

/**
* loop through all trades (historic and currently open) and
* sum up all profits (including swap and commission).
*/
double getAllProfitFiltered(int magic=-1, string comment=""){
   int cnt, total;
   double floating = 0;
   double realized = 0;
   static int last_closed_ticket = 0;
   string cache_name; 
   
   // we need a unique name under which to cache the realized P&L later
   if (IsTesting()){
      cache_name = "profit_cache@@" + magic + "@" + comment;
   }else{
      cache_name = "profit_cache@" + magic + "@" + comment;
   }
   
   // sum up the floating
   total=OrdersTotal();
   for(cnt=0; cnt<total; cnt++){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if ((magic == -1 || OrderMagicNumber() == magic) 
       && (comment == "" || StringFind(OrderComment(), comment, 0) != -1)
      ){
         floating += OrderProfit() + OrderSwap() + OrderCommission();
      }
   }
   
   // Now calculate the total realized profit.
   // We first check if the order history has changed since 
   // the last tick by looking at the newest ticket number.
   // If there was no change then we can assume that no trade
   // has been closed and we can simply use the cached value
   // of the previously calculated realized profit.
   total=OrdersHistoryTotal();
   OrderSelect(total-1, SELECT_BY_POS, MODE_HISTORY);
   if (last_closed_ticket != OrderTicket()){
   
      // history is different from last time, so we must do 
      // the expensive loop and sum up all realized profit
      last_closed_ticket = OrderTicket();
      realized = 0;
      for(cnt=0; cnt<total; cnt++){
         OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);
         if ((magic == -1 || OrderMagicNumber() == magic) 
          && (comment == "" ||  StringFind(OrderComment(), comment, 0) != -1)
         ){
            realized += OrderProfit() + OrderSwap() + OrderCommission();
         }
      }
      // remember it for the next call.
      // We need to store it separately for every possible filter.
      // We dont have hash tables in mql4, so we must abuse 
      // the global variables function to store name-value pairs.
      GlobalVariableSet(cache_name, realized);      
   }else{
   
      // history not changed. retrieve the cached value.
      realized = GlobalVariableGet(cache_name);
   }
   
   return (floating + realized);
}

/**
* Open the chart file. In testing mode this will open the file
* only when called for the first time and cache the file handle
* for subsequent calls to speed up things. The corresponding
* fileCloseEx() function will do nothing when in testing mode.
*/
int fileOpenEx(string name, int mode){
   if (IsTesting()){
      if (__chart_file == 0){
         __chart_file = FileOpenHistory(name, mode);
      }
      return(__chart_file);
   }else{
      return(FileOpenHistory(name, mode));
   }
}

/**
* close the file. Keep the file open when in teting mode.
*/
void fileCloseEx(int file){
   if (!IsTesting()){
      FileClose(file);
   }else{
      //FileFlush(file);
   }
}

/**
* enforce closing of the file (in backtesting mode when it is held open)
*/ 
void forceFileClose(){
   if(__chart_file != 0){
      FileClose(__chart_file);
      __chart_file = 0;
   }
}